      PROGRAM DIFF
C
      IMPLICIT LOGICAL ( A - Z )
      EXTERNAL UPKAN, UNPKI, UPKTIM
      REAL UPKAN, UNPKI, UPKTIME
      INTEGER*2 IARR(256)         ! INTEGER ARRAY TO READ FILE RECORDS
      REAL ANGLOW                 ! LOWEST ANGLE
      REAL ANGHIG                 ! HIGHEST ANGLE
      REAL CNTMAX                 ! MAX .COUNT
      INTEGER*2 NSCANS            ! NUMBER OF SCANS
      REAL SANG                   ! STARTING ANGLE IN THE ACTURAL RECORD
      REAL EANG                   ! ENDING ANGLE   "   "     "       "
      REAL STSIZE                 ! STEP SIZE      "   "     "       "
      REAL TIME                   ! COUNTING TIME  "   "     "       "
      INTEGER*2 NPOINT            ! NR. OF DATA POINTS "     "       "
      REAL ANGLE
      REAL COUNTS
      INTEGER*2 I                 ! COUNTER VARIABLE
      INTEGER*2 NREC              ! RECORD NUMBER TO BE READ
      INTEGER*2 NR, NRPRV         ! ACTUAL AND PREVIOUS SCAN NUMBER
      CHARACTER*32 FILIN          ! INPUT FILENAME
      CHARACTER*32 FILOUT         ! OUTPUT FILENAME
C
      WRITE (6,'(A)') '$Filename > '
      READ  (5,'(A)') FILIN
 1100 OPEN (11,NAME=FILIN,TYPE='OLD',ACCESS='DIRECT',RECL=128,ERR=1234)
      FILOUT=FILIN(1:11)//'DMAC'
      OPEN (77,FILE=FILOUT,CARRIAGECONTROL='LIST',STATUS='NEW')
      READ  (11'1 , ERR=1234) ( IARR(I), I=1,256 )
C
      ANGLOW = UPKAN ( IARR(27) )                ! LOWEST ANGLE IN THE FILE
      ANGHIG = UPKAN ( IARR(28) )                ! HIGHEST ANGLE IN THE FILE
      CNTMAX = UNPKI ( IARR(33) )                ! MAX. COUNT VALUE IN THE FILE
      NSCANS = IARR(151)                         ! TOTAL NUMBER OF SCANS
 1200 NREC = 2                                   ! FIRST RECORD TO BE READ 
      NRPRV= 0                                   ! PREVIOUS SCAN NUMBER IS 0  
C
 1250 READ (11'NREC , ERR=1234 ) ( IARR(I), I=1,256 ) 
      SANG   = UPKAN ( IARR(1) )                 ! STARTING ANGLE IN THIS RECORD
      STSIZE = UPKAN ( IARR(2) )                 ! STEPSIZE
      TIME   = UPKTIM( IARR(3) )                 ! COUNTING TIME 
      EANG   = UPKAN ( IARR(4) )                 ! ENDING ANGLE
      NR     = IARR(6) .AND. "377                ! SCAN NUMBER
C
      IF ( NR .NE. NRPRV ) WRITE (77, '(X,F7.3,A,F10.0)') 
     *       SANG, '	', UNPKI (IARR(7))
      NPOINT = ( EANG - SANG ) / STSIZE + 0.5    ! NUMBER OF DATA POINTS
      ANGLE  = SANG
      DO 1260 , I=1,NPOINT                       ! LIST ALL DATA POINTS 
         ANGLE  = ANGLE + STSIZE
         COUNTS = UNPKI ( IARR(6+I) )
         WRITE  (77,'(X,F7.3,A,F10.0)') ANGLE, '	',COUNTS
 1260 CONTINUE 
      NREC = NREC + 1                           ! READ NEXT RECORD
      GOTO 1250 
 1234 END
C******************************************************************************
      REAL FUNCTION UPKAN (IPKAN)
C
      INTEGER*2 IPKAN                                    ! PACKED ANGLE VALUE
      UPKAN = 0.005 * IPKAN
      IF (IPKAN .GE. 0) GOTO 9000
      UPKAN = - UPKAN - 0.0025
 9000 END
C******************************************************************************
      REAL FUNCTION UNPKI (IPACK)
C
      INTEGER*2 IPACK                   ! CONTAINS THE INTENSITY TO BE UNPACKED
      REAL R                            ! TEMPORARY VALUE
      IF ( IPACK .LT. -1000 ) GOTO 2000
      IF ( IPACK .EQ. O ) IPACK = 1     ! PREVENT THAT UNPKI CAN BE  0
      UNPKI = ( FLOAT(IPACK) /10 )**2 * ISIGN(1,IPACK)
      GOTO 3000
 2000 R = FLOAT( IPACK .AND. "77777 ) + 32768.  
      UNPKI = (R/10.) **2
 3000 END
C******************************************************************************
      REAL FUNCTION UPKTIM (ITIME)
C
      INTEGER*2 ITIME                   ! PACKED COUNT TIME.
      IF (ITIME .GE. 0) UPKTIM = 0.001 * ITIME
      IF (ITIME .LT. 0) UPKTIM =-0.050 * ITIME
      END 