      SUBROUTINE INIT 
C     BASIC PARAMETERS FOR THE ICE MODEL
C
      PARAMETER   (   L=18,    M=14,    LMD=L*M,  LMD2=L*M/2,
     1                LM=L-1,  L2=L/2,  LMDP=(L+1)*(M+1),
     2                MM=M-1,  M2=M/2,  M2M=M/2-1, LDO=4*L  )
      COMMON /CORR/   F(L,M),F0,BETA
      COMMON /IPARM/  RHOICE,H0,HNU,HNU2,ARMIN,ARMAX,HMIN,RHOSNO,CC,CL
      COMMON /DRV/    DX,DXSQ,DY,DYSQ,SX2,SY2,SXY
      COMMON /STP/    T,DT,NTMES,NRST,NRREC,NPLT,NSTAT,IIC
      CHARACTER*40    CIDENT
      COMMON /ID/     CIDENT
      COMMON /COORD/  PM(L,M),PN(L,M),
     1                DNDX(L,M),DMDY(L,M),PMI(L,M),PNI(L,M)
      COMMON /COORDH/  PMH(0:L,0:M),PNH(0:L,0:M)
C     ICE VELOCITY ARRAYS
C
      COMMON /VEL/    U(L,M,3), V(L,M,3)
C     ICE THICKNESS AND COMPACTNESS VARIABLES
C
      COMMON /THCK/   H(0:L,0:M,2), A(0:L,0:M,2), HSN(0:L,0:M,2)
C     GEOSTROPHIC WIND AND OCEAN CURRENTS, AND THE NECESSARY DRAG INFORATION
C
      COMMON /FRWND/  RHOAIR,CDWIN,SINWIN,COSWIN,UWIN(L,M),VWIN(L,M)
      COMMON /FRWAT/  RHOWAT,CDWAT,SINWAT,COSWAT,UWAT(L,M),VWAT(L,M)
C     ATMOSPHERIC THERMODYNAMIC FORCING VARIABLES
C
      COMMON /THFOR/  TAIR(0:L,0:M),QA(0:L,0:M),
     1                FLO(0:L,0:M),FSH(0:L,0:M),UG(0:L,0:M)
      COMMON /THPAR/  Q0,D1,D2I,D2W,D3,CON,ALBI,ALBM,ALBW,ALBSN,ALBSNM,
     1                QS1,QSW,QSI,TQW,TQI,TMELT,TFREZ,CONSN,RPREC
C     VISCOSITY PARAMETERS AND THE VISCOSITIES AND ICE PRESSURE
C
      COMMON /VISCP/  PSTAR,CSTAR,ECCEN,ZMAX,ZMIN,GMIN,ECM2
      COMMON /PRESS/  P(L,M)
C     PARAMETERS FOR THE OVERRELAXATION ROUTINE
C
      COMMON /RELAXP/ MMAX,VRMAX,WT
C     THE TEMPERATURE OF THE ICE (ACTUALLY AT THE AIR-ICE OR SNOW INTERFACE
      COMMON /TEMP/   TICE(0:L,0:M)
C     FOR MULTIPLE LAYER THERMODYNAMICS, INCLUDE THE NEXT STATEMENT
      COMMON /TEMPM/  TICM(0:L,0:M,7)
      COMMON /WORK/ TMP(0:L,0:M)
      COMMON /MASK/ VM(L,M),HM(0:L,0:M),OM(0:L,0:M),VMS(L,M),
     1              FLM(0:L,0:M,2)
      COMMON /OUTFLOW/ NOUT,IOUT(LDO),JOUT(LDO)
      COMMON /COORDSC/ PMS(L2,M2,4),PNS(L2,M2,4),
     1               PMIS(L2,M2,4),PNIS(L2,M2,4)
      COMMON /SCRGO/ IGO(L,M)
C     COMMON BLOCK FOR MIXED LAYER
      COMMON /PML/QS(0:L,0:M),QT(0:L,0:M),QH(0:L,0:M),QSB(0:L,0:M), 
     +QTB(0:L,0:M),QHB(0:L,0:M),QSU(0:L,0:M),QTU(0:L,0:M),
     +QHSTO(0:L,0:M),HS(0:L,0:M),HT(0:L,0:M),QV(0:L,0:M), 
     +QRHO(0:L,0:M),QW(0:L,0:M),IEN(0:L,0:M),FW(0:L,0:M),
     +MLFIX
      COMMON /PMLPARM/ TF,SICE,QHW,QHS,QHSMAX,DCVM,ENTMAX,WUP,CW,
     1                 PI,GAMMA,BETAS,BETAT,EPSAA,ALF,RTC,STC,STCB,QTOC
      COMMON /SNOFLG/SNOFLG
C
C     SET TIME-STEPPING PARAMETERS
C     NUMBER OF TIME STEPS
      NTMES=365 
C     TIME STEPS BETWEEN WRITTING OUT RESTART RECORDS
      NRST=NTMES
C     TIME STEPS BETWEEN STATISTICS OUTPUT
      NSTAT=5 
C     TIME STEPS BETWEEN PLOTS AND PRINT OUTS (SHOULD BE AN INTEGER TIMES
C     NSTAT)
      NPLT=40 
C     NUMBER OF RESTART RECORDS TO READ ( = 0 TO USE VALUES ASSIGNED BELOW
      NRREC=1
C
C     USER SUPPLIED PARAMETERS (USE MKS UNITS): 
C     GRID SIZE:  
      DX = 2.2236E+05
      DY = 2.2236E+05
C     CORIOLIS PARAMETERS
      F0 = 1.46E-04
      BETA = 0.0
C     SPECIFY WHETHER WE ARE IN NORTHERN OR SOUTHERN HEMISPHERE
C     (1.0 = NORTHERN, -1.0 = SOUTHERN)
      HEMI = -1.0
C     TIME STEP
      DT = 0.864E+05
C
C     SET UP ICE PARAMETERS
      RHOICE=0.91E+03
      H0 = 0.5
      ARMIN = 0.15
      ARMAX = 1.0
      HMIN = 0.05
C     CC = RHOICE*CP IN JOULE/DEG C/M**3
      CC = 4.2E6
      CL = 3.02E8 
C     FOR SNOW
      RHOSNO = 0.33E+03
C     SET UP ICE PRESSURE AND VISCOSITIES PARAMETERS, IN MKS UNITS
      PSTAR=5.0E+03*5.5 
C     PSTAR=1.0E5 
      ECCEN =2.0
      ECM2 = 1.0/ECCEN**2
C     ECM2=0. 
      CSTAR = 20. 
      ZMAX = 5.0E12/2.0E04
      ZMIN = 4.0E+08
      GMIN = 1.0E-20
C     SET UP PARAMETERS FOR FORCING FROM WIND AND OCEAN
      RHOAIR= 1.3E+00
      RHOWAT= 1.0E+03
C     DRAG COEFF.
      CDWIN = 1.2E-03
      CDWAT = 5.5E-03
C 20 DEG GIVES SIN EQUAL TO .34202
      SINWIN=0.4226E+00
      COSWIN=0.9063E+00
      SINWAT=0.4226E+00
      COSWAT=0.9063E+00
C     IF WE ARE IN SOUTHERN HEMISPHERE, THEN HAVE EKMAN TURNING
C     IN THE OPPOSITE DIRECTION
      SINWIN = HEMI*SINWIN
      SINWAT = HEMI*SINWAT
C     SET UP PARAMETERS FOR THE ICE THERMODYNAMIC BALANCE
C     1/VOLUMETRIC HEAT OF FUSION
      Q0=1.0E-06/302.0E+00
C     BULK SENSIBLE HEAT TRANSFER COEFF.
      D1=2.284E+00
C     BULK LATENT HEAT TRANSFER COEFF.
      D2W=5.6875E+03
      D2I=6.4474E+03
C     STEFAN-BOLTZMANN CONST.
      D3=5.5E-08
C     CONDUCTIVITY OF ICE
      CON = 2.1656
C     CONDUCTIVITY OF SNOW
      CONSN = 0.31
C     ALBEDOS
      ALBI = 0.75
      ALBM = 0.66 
      ALBW = 0.10
      ALBSN = 0.85
      ALBSNM = 0.75
C*****SNOFLG = 0 : NO SNOW
C*****SNOFLG = 1 : INCLUDE SNOW LAYER
      SNOFLG = 0. 
C
C     MIXED LAYER PARAMETERS
C
C*****MLFIX=1 : FIXED MIXED LAYER 
C*****MLFIX=0 : PROGNOSTIC MIXED LAYER
      MLFIX=0 
      FLAGM = FLOAT(MLFIX)
      TF = -1.96
      QHW = 7.0
      QHS = 50.0
      QHSMAX=50.0 
      DCVM=EXP(-QHSMAX/QHS) 
      ENTMAX=30.0 
      WUP=3.0E-7
      IF(MLFIX.EQ.1) WUP=0.0
      SICE = 5.0
      CW = 0.005
      PI = 3.14159
      GAMMA = 24.0
      BETAS = 0.0008
      BETAT = 0.00004
      EPSAA=2.0E-6
      ALF=0.3 
C*****RTC=TIME CONSTANT OF MIXED LAYER RETREAT (6 DAYS) 
      RTC=10.0*86400.0/DT 
C*****STC=SALINITY TIME CONSTANT
      STC=300.0*86400.0/DT
C      STCB=200.0*86400.0/DT
C     QTOC=OCEANIC HEATFLUX IN W/M**2 
      QTOC = 3.26 
C     QTOC=1.02 
C
C     CONSTANTS FOR THE SPECIFIC HUMIDITY TERMS FOR BOTH OVER WATER
C     AND ICE.
      QS1=6.11*.622/1013.0E+00
      QSW=17.2694
      TQW=237.3
      QSI=21.8746
      TQI=265.5
C     TMELT IS 0 DEG C EXPRESSED IN DEG K. (USED TO CALCULATE RADIATION TERM)
      TMELT=273.16
C     FREEZING TEMPERATURE FOR OCEAN (IN DEG C)
      TFREZ=-1.96
C     PRECIPITATION RATE (M/SEC)
      RPREC = 0.35/(365.*8.64E+04)
C     RPREC = 1.00/(365.*8.64E+04)
      IF(MLFIX.EQ.1) RPREC=0. 
C     SET HORIZONTAL DIFFUSION PARAMETERS FOR USE IN THE H AND A
C     EQUATIONS.  HNU = COEFF. FOR REGULAR DIFFUSION
C     HNU2 = COEFF. FOR BIHARMONIC DIFFUSIVE OPERATOR
C     FOR HNU IN CM**2/S
      HNU = 0.004*DX
      HNU2 = DX**2*HNU
C
C     DERIVED CONSTANTS
C
      XL=DX*FLOAT(LM)
      DXSQ=DX*DX
      YL=DX*FLOAT(MM)
      DYSQ=DY*DY
      SX2 = 0.5/DXSQ
      SY2 = 0.5/DYSQ
      SXY = 0.25/(DX*DY)
C
C     NEW RUNS START AT T=0
      T = 0.0
C
C     SET COORDINATE MAPPING FACTORS
      DO 209 J = 0,M
      DO 209 I = 0,L
        PMH(I,J) = 1.
  209   PNH(I,J) = 1.
      DO 210 J = 1,MM
        DO 210 I = 1,L
          DNDX(I,J) = 0.
  210     DMDY(I,J) = 0.
      DO 211 J=1,M
        DO 211 I=1,L
          PMI(I,J) = 0.5*(1./PMH(I,J-1)+1./PMH(I,J))
  211     PNI(I,J) = 0.5*(1./PNH(I-1,J)+1./PNH(I,J))
C     TAKE SUBSET OF METRIC FOR USE IN VELOCITY CALCULATIONS,
C     NOTE: THIS IS NECESSARY FOR CYBER OPTIMIZATION
      DO 212 J=1,M
        DO 212 I=1,L
          PM(I,J) = PMH(I,J)
  212     PN(I,J) = PNH(I,J)
C
C     SET CORIOLIS PARAMETER
      DO 220 J = 1,M
      Y = (FLOAT(J)-0.5)*DY
      BETAY = BETA*(Y-0.5*YL)
      DO 221 I = 1,L
  221 F(I,J) = HEMI*F0 + BETAY
  220 CONTINUE
C     SET-UP PARAMETERS FOR THE RELAX SUBROUTINE
      MMAX=800
      VRMAX = 5.0E-06
      WT = 1.5
C     SET UP POINTERS FOR SCRAMBLING THE DATA INTO ODD-ODD,
C     EVEN-EVEN, EVEN-ODD, AND ODD-EVEN SECTIONS
      IC = 0
      DO 50 ICO = 1,2
        DO 50 J0 = 1,2
          DO 50 J=J0,M,2
            IB = MOD(J+ICO,2)+1
            DO 50 I=IB,L,2
               IC = IC+1
               IGO(I,J) = IC
   50 CONTINUE
C     SCRAMBLE THE METRICS FOR USE IN RELAX (IN DDX, DDY, AND MADV)
      CALL SCRAM(PM,PMS,1)
      CALL SCRAM(PN,PNS,1)
      CALL SCRAM(PMI,PMIS,1)
      CALL SCRAM(PNI,PNIS,1)
C     INITIALIZE HORIZONTAL BOUNDARY CONDITIONS
      CALL BCSINIT
C********** INITIALIZE ICE AND MIXED LAYER VARIABLES
C     IF WE ARE TO START FROM A RESTART TAPE, THEN READ IN THE VALUES
      IF(NRREC.NE.0)  THEN
C     READ THROUGH THE RESTART RECORDS TO THE CORRECT ONE
        DO 420  K=1,NRREC
          READ(9,901,ERR=100) ((U(I,J,1),V(I,J,1),I=1,L),J=1,M)
          READ(9,901,ERR=100) ((H(I,J,1),A(I,J,1),I=0,L),J=0,M)
          READ(9,901,ERR=100) ((HSN(I,J,1),TICE(I,J),
     1                  I=0,L),J=0,M)
          READ(9,901,ERR=100) ((QT(I,J),QS(I,J),QH(I,J),
     1                  I=0,L),J=0,M)
          READ(9,901,ERR=100) ((QTB(I,J),QSB(I,J),QHB(I,J),
     1                  I=0,L),J=0,M)
          READ(9,901,ERR=100) ((QTU(I,J),QSU(I,J),
     1                  I=0,L),J=0,M)
          READ(9,901,ERR=100) (((TICM(I,J,N),I=0,L),J=0,M),N=1,7)
  901 FORMAT(5G13.4)
  420 CONTINUE
      ELSE
C     SET INITIAL CONDITIONS FOR INTERIOR POINTS
         DO 280  J=1,M
         DO 280  I=1,L
         U(I,J,1) = 0.05*VM(I,J)
  280    V(I,J,1) = 0.05*VM(I,J)
         DO 281  J=0,M
           DO 281  I=0,L
             H(I,J,1) = 2./.91*OM(I,J)
             A(I,J,1) = 1.0*OM(I,J)
             HSN(I,J,1) = 0.0
             TICE(I,J) = -.16
             QH(I,J) = 60.0
             QS(I,J) = 33.3
             QT(I,J) = TFREZ
             QSB(I,J) = 34.8
             QTB(I,J) = 0.6
             IF(J.GT.5) QTB(I,J)=1.0
             QHB(I,J) = 3000.0
             QTU(I,J) = 70.0
             QSU(I,J) = 20.0
  281  CONTINUE
      END IF
      DO 285 J=0,M
        DO 285 I=0,L
          HSN(I,J,1) = HSN(I,J,1)*SNOFLG
  285 CONTINUE
C
C     PRINTOUT PARAMETERS
      WRITE(16,402) CIDENT
      WRITE(15,402) CIDENT
      WRITE(*,402) CIDENT
  402 FORMAT(1X,A40)  
      WRITE(*,403)  L,M,DX,DY,DT,H0,F0,MLFIX,PSTAR,ECCEN,CSTAR,
     1              ZMAX,ZMIN,GMIN,
     2              ALBI,ALBM,ALBW,ALBSN,ALBSNM,SNOFLG,
     3              CON,CONSN,RPREC,ALF
  403 FORMAT(' L      = ',I3,     ' M      = ',I3,/,
     1 ' DX     = ',1PE12.3,' DY     = ',1PE12.3,' DT     = ',1PE12.3,/,
     2 ' H0     = ',1PE12.3,' F0     = ',1PE12.3,' MLFIX  = ',I1,/,
     3 ' PSTAR  = ',1PE12.3,' ECCEN  = ',1PE12.3,' CSTAR  = ',1PE12.3,/,
     4 ' ZMAX   = ',1PE12.3,' ZMIN   = ',1PE12.3,' GMIN   = ',1PE12.3,/,
     5 ' ALBI   = ',1PE12.3,' ALBM   = ',1PE12.3,' ALBW   = ',1PE12.3,/,
     6 ' ALBSN  = ',1PE12.3,' ALBSNM = ',1PE12.3,' SNOFLG = ',F3.1,/,
     7 ' CON    = ',1PE12.3,' CONSN  = ',1PE12.3,' RPREC  = ',1PE12.3,/,
     8 ' ALF    = ',1PE12.3 )
C
C     NOW CALCULATE SOME MIXED-LAYER PARAMETERS
      DO 70 J=0,M
        DO 70 I=0,L 
C***IN EXP MODEL QSU=QDS AND QTU=QDT
          QSU(I,J)=QSU(I,J)*(1.0-FLAGM) 
          QTU(I,J)=QTU(I,J)*(1.0-FLAGM) 
C PALAEO BC FOR DEEP OCEAN
C     QTB(I,J)=0. 
C 
          HT(I,J)=(QT(I,J)-QTB(I,J))*(QH(I,J)+QTU(I,J))+QTB(I,J)* 
     1QHB(I,J)
          HS(I,J)=(QS(I,J)-QSB(I,J))*(QH(I,J)+QSU(I,J))+QSB(I,J)* 
     1QHB(I,J)
C     INITIAL VALUES FOR SNOW COVER 
C     HSN(I,J,1)=0.1*H(I,J,1)*SNOFLG*OM(I,J)
   70 CONTINUE
C
      RETURN
  100 WRITE(*,400)
  400 FORMAT('1  READ ERROR IN INIT ')
      STOP
      END